@echo off
if "%~dpnx1"=="" goto usage

:scriptStart
set wwpacker_dlcRegionHex=-1
set wwpacker_label=[Patched]
set wwpacker_workFolder=''
if exist "%~dpnx1\*.tmd" goto scriptStartT1E
"%~dp0WadDataInfo.exe" /n "%~dpnx1"
if errorlevel 1 pause
echo.
if errorlevel 1 goto usage
set wwpacker_workFolder=.
:scriptStartT1E
if not %wwpacker_workFolder%=='' goto isWadFile
goto isWadFolder

:isWadFile
set ww_ipath=%~dp1
for %%k in ("%~dp0waddatainfo.exe") do set wwpacker_cmd=%%~fsk
for %%k in ("%ComSpec%") do set wwpacker_findcmd=%%~dpk
for %%k in ("%wwpacker_findcmd%find.exe") do set wwpacker_findcmd=%%~fsk
for /F "tokens=1,2" %%k in ('%wwpacker_cmd% /n "%~dpnx1" ^| %wwpacker_findcmd% /I "Path: "') do if /I '%%k'=='Path:' set wwpacker_workFolder=%%l
set wwpacker_cmd=
set wwpacker_findcmd=
set wwpacker_workFolder=%wwpacker_workFolder:~1,8%%wwpacker_workFolder:~10,8%
goto iosOption

:isWadFolder
%~d1
cd "%~dpnx1"
call "%~dp0task-wwpack-prepare.bat" "%~dpnx1"
echo _____________________________________________________________________
%~d0
cd "%~dp0"
"%~dp0WadDataInfo.exe" /n "%~dpnx1\_title.tmd"
echo.

:iosOption
verify > nul
echo Enter the target IOS Flag [0-255] [decimal value] :
echo (Enter nothing to skip IOS patch)
echo e.g. 31=IOS31, 33=IOS33, 35=IOS35, 37=IOS37, 53=IOS53, 55=IOS55
echo Tips: If you got no idea about this, just skip this patch.
set wwpacker_iosHex=-1
set wwpacker_iosDec=-1
set /P wwpacker_iosDec=Your input : 
if "%wwpacker_iosDec%"=="-1" goto iosOptionEnd
set /A wwpacker_iosDec=%wwpacker_iosDec%
echo.
if errorlevel 1 goto iosOption
if %wwpacker_iosDec% LSS 0 goto iosOption
if %wwpacker_iosDec% GTR 255 goto iosOption
set hexValue=
set decValue=%wwpacker_iosDec%
set hexLength=1
set returnLabel=iosOptionD2H
goto decToHex
:iosOptionD2H
set wwpacker_iosHex=%hexValue%
set hexValue=
set hexLength=
set decValue=
set returnLabel=
echo Target IOS Flag = IOS%wwpacker_iosDec%. Correct? [Y/N]
set /P wwpacker_ios_ans=Your input : 
echo.
if /I not "%wwpacker_ios_ans%"=="Y" goto iosOption
set wwpacker_label=%wwpacker_label%[IOS%wwpacker_iosDec%]
:iosOptionEnd
echo.

:regionOption
verify > nul
echo Enter the target Region Flag [hexadecimal value] :
echo (Enter nothing to skip region patch)
echo e.g. 0=Japan, 1=USA, 2=Europe, 3=RegionFree
echo Tips: If you got no idea about this, just enter '3' [RegionFree].
set wwpacker_regionHex=-1
set wwpacker_regionDec=-1
set /P wwpacker_regionHex=Your input : 
if "%wwpacker_regionHex%"=="-1" goto regionOptionEnd
if "%wwpacker_regionHex:~1%"=="" set wwpacker_regionHex=0%wwpacker_regionHex%
if %wwpacker_regionHex% GEQ 0 ( set /A wwpacker_regionDec=0x%wwpacker_regionHex%
) else ( set wwpacker_regionDec=-1 )
echo.
if errorlevel 1 goto regionOption
if %wwpacker_regionDec% GTR 255 goto regionOption
if %wwpacker_regionDec% LSS 0 (
echo Target Region Flag = NO MODIFICATION. Correct? [Y/N]
) else if %wwpacker_regionDec% EQU 0 (
echo Target Region Flag = Japan. Correct? [Y/N]
set wwpacker_labelTmp=RegionJAP
) else if %wwpacker_regionDec% EQU 1 (
echo Target Region Flag = USA. Correct? [Y/N]
set wwpacker_labelTmp=RegionUSA
) else if %wwpacker_regionDec% EQU 2 (
echo Target Region Flag = Europe. Correct? [Y/N]
set wwpacker_labelTmp=RegionEUR
) else if %wwpacker_regionDec% EQU 3 (
echo Target Region Flag = ALL REGIONS [RegionFree]. Correct? [Y/N]
set wwpacker_labelTmp=RegionFree
) else (
echo Target Region Flag = Region %wwpacker_regionDec% [decimal]. Correct? [Y/N]
set wwpacker_labelTmp=Region%wwpacker_regionDec%
)
set /P wwpacker_region_ans=Your input : 
echo.
if /I not "%wwpacker_region_ans%"=="Y" goto regionOption
set wwpacker_label=%wwpacker_label%[%wwpacker_labelTmp%]
set wwpacker_labelTmp=
:regionOptionEnd
echo.

:changeIdOption
verify > nul
echo Enter the target Title ID [4 characters] :
echo (Enter nothing to skip changing Title ID)
echo e.g. ABCD, HBXX, WAAJ, WBBE, WCCP
set wwpacker_titleId=-1
set /P wwpacker_titleId=Your input : 
echo.
if "%wwpacker_titleId%"=="-1" goto changeIdOptionEnd
if "%wwpacker_titleId:~3%"=="" goto changeIdOption
if not "%wwpacker_titleId:~4%"=="" goto changeIdOption
echo Target Title ID = '%wwpacker_titleId%'. Correct? [Y/N]
set /P wwpacker_id_ans=Your input : 
echo.
if /I not "%wwpacker_id_ans%"=="Y" goto changeIdOption
set wwpacker_label=%wwpacker_label%[TitleID]
:changeIdOptionEnd

:versionOption
verify > nul
echo Enter the target Version [1-65535] [decimal value] :
echo (Enter nothing to skip Version patch)
echo Tips: If you got no idea about this, just skip this patch.
set wwpacker_versionHex=-1
set wwpacker_versionDec=-1
set /P wwpacker_versionDec=Your input : 
if "%wwpacker_versionDec%"=="-1" goto versionOptionEnd
set /A wwpacker_versionDec=%wwpacker_versionDec%
echo.
if errorlevel 1 goto versionOption
if %wwpacker_versionDec% LSS 1 goto versionOption
if %wwpacker_versionDec% GTR 65535 goto versionOption
set hexValue=
set decValue=%wwpacker_versionDec%
set hexLength=2
set returnLabel=versionOptionD2H
goto decToHex
:versionOptionD2H
set wwpacker_versionHex=%hexValue%
set hexValue=
set hexLength=
set decValue=
set returnLabel=
echo Target Version = %wwpacker_versionDec%. Correct? [Y/N]
set /P wwpacker_version_ans=Your input : 
echo.
if /I not "%wwpacker_version_ans%"=="Y" goto versionOption
REM set wwpacker_label=%wwpacker_label%[v%wwpacker_versionDec%]
:versionOptionEnd
echo.

:fakeTicketOption
verify > nul
echo Enter the code for the Fake Ticket patches [5 characters] :
echo (Enter nothing or '00000' to skip these patches)
echo * The code is composed of ZERO or NON-ZERO alphanumeric characters.
echo * Each character represents a flag and '0' means NO patching.
echo Flags:
echo   1:TicketID,    2:ConsoleID,    3:Reserved VC data,
echo   4:Amount of bought DLC contents,    5:Reserved DLC data
echo e.g. 11100 patches flags 1 to 3. 00011 patches flags 4 and 5.
set wwpacker_fakeTicket=00000
set /P wwpacker_fakeTicket=Your input : 
echo.
if "%wwpacker_fakeTicket%"=="00000" goto fakeTicketOptionEnd
if "%wwpacker_fakeTicket:~4%"=="" goto fakeTicketOption
if not "%wwpacker_fakeTicket:~5%"=="" goto fakeTicketOption
echo Fake Ticket Patch Code = '%wwpacker_fakeTicket%'
if %wwpacker_fakeTicket:~0,1% NEQ 0 echo  - Patch 1:TicketID
if %wwpacker_fakeTicket:~1,1% NEQ 0 echo  - Patch 2:ConsoleID
if %wwpacker_fakeTicket:~2,1% NEQ 0 echo  - Patch 3:Reserved VC data
if %wwpacker_fakeTicket:~3,1% NEQ 0 echo  - Patch 4:Amount of bought DLC contents
if %wwpacker_fakeTicket:~4,1% NEQ 0 echo  - Patch 5:Reserved DLC data
echo Correct? [Y/N]
set /P wwpacker_fakeTicket_ans=Your input : 
echo.
if /I not "%wwpacker_fakeTicket_ans%"=="Y" goto fakeTicketOption
set wwpacker_label=%wwpacker_label%[FakeTik]
:fakeTicketOptionEnd

:plusOption
echo Do you want to patch game language, region string, video mode, 001 check,
echo 002 check, JAP WiiFit save conflict or something else? [Y/N]
echo (Enter nothing or 'N' to skip these patches)
set wwpacker_plus_ans=N
set wwpacker_plus=0
set /P wwpacker_plus_ans=Your input : 
echo.
if /I "%wwpacker_plus_ans%"=="N" goto plusOptionEnd
if /I not "%wwpacker_plus_ans%"=="Y" goto plusOption
set wwpacker_plus=1
:plusOptionEnd

if '%wwpacker_label%'=='[Patched]' if %wwpacker_plus% EQU 0 if %wwpacker_versionHex% LEQ 0 set wwpacker_label=[NoMod]
set ww_idrv=%~d1
if %wwpacker_workFolder%=='' set ww_ipath=%~dpnx1
call "%~dp0task-wwpack-main.bat" "%~dpnx1"
@echo off
goto end


REM decToHex
REM [IN] %decValue% - decimal value
REM [IN] %hexLength% - the length of output %hexValue% in byte
REM [IN] %returnLabel% - the label to return when this function ends
REM [OUT] %hexValue% - hexadecimal value string without '0x' at the beginning
:decToHex
if %hexLength% LEQ 0 goto %returnLabel%
set /A hexBitLength=8
:decToHexByte
set /A dec4Bits="%decValue% & 0xF"
if %dec4Bits% EQU 10 ( set hexValue=A%hexValue%
) else if %dec4Bits% EQU 11 ( set hexValue=B%hexValue%
) else if %dec4Bits% EQU 12 ( set hexValue=C%hexValue%
) else if %dec4Bits% EQU 13 ( set hexValue=D%hexValue%
) else if %dec4Bits% EQU 14 ( set hexValue=E%hexValue%
) else if %dec4Bits% EQU 15 ( set hexValue=F%hexValue%
) else set hexValue=%dec4Bits%%hexValue%
set /A hexBitLength=%hexBitLength% - 4
set /A decValue="%decValue% >> 4"
set dec4Bits=
if %hexBitLength% GTR 0 goto decToHexByte
set hexBitLength=
set /A hexLength=%hexLength% - 1
goto decToHex


:usage
echo Usage:
echo Drag and drop the wad files/folders onto the icon of this batch script.
echo.

:end
shift /1
if not "%~dpnx1"=="" goto scriptStart
pause
echo.
