@echo off
if "%~dpnx1"=="" goto main_error1
if not exist "%~dp0common-key.bin" goto main_error3
if %wwpacker_plus% EQU 2 if not exist "%~dp0cert.sys" goto main_error4
if %wwpacker_plus% EQU 3 if not exist "%~dp0loader.bin" goto main_error5

if %wwpacker_workFolder%=='' goto extractWadEnd
:extractWad
set ww_iname=%~n1
set ww_iext=%~x1
call "%~dp0task-wwunpack.bat" "%~dpnx1"
@echo off
set ww_iname=
set ww_iext=
set ww_ipath=%ww_ipath%%wwpacker_workFolder%
if not exist "%ww_ipath%\%wwpacker_workFolder%.tmd" goto main_error6
:extractWadEnd

%ww_idrv%
cd "%ww_ipath%"
if errorlevel 1 goto main_error2
call "%~dp0task-wwpack-prepare.bat" "%ww_ipath%"
@echo off

set wwpacker_signWAD=0
set wwpacker_signOnlyTMD=0
REM For custom or plus script...
if %wwpacker_plus% EQU 1 goto plusTask
goto plusTaskEnd
:plusTask
	call "%~dp0task-wwpack-plus.bat" "%ww_ipath%"
	@echo off
	set wwpacker_signWAD=1
:plusTaskEnd
REM For freethebug script...
if %wwpacker_plus% EQU 2 goto ftbTask
goto ftbTaskEnd
:ftbTask
	call "%~dp0task-wwpack-freethebug.bat" "%ww_ipath%"
	@echo off
	if %wwpacker_plus% EQU 2 (
	set wwpacker_signWAD=1
	set wwpacker_signOnlyTMD=1
	)
:ftbTaskEnd
REM For loader script...
if %wwpacker_plus% EQU 3 goto loaderTask
goto loaderTaskEnd
:loaderTask
	call "%~dp0task-wwpack-loader.bat" "%ww_ipath%"
	call "%~dp0task-wwpack-plus.bat" "%ww_ipath%"
	@echo off
	set wwpacker_signWAD=1
:loaderTaskEnd
REM For justsign script...
if %wwpacker_plus% EQU -1 set wwpacker_signWAD=1
set wwpacker_plus=

if %wwpacker_iosHex% GTR 0 (
	echo _____________________________________________________________________
	echo Patch IOS Flag to IOS%wwpacker_iosDec%...
	"%~dp0HTool.exe" /p _title.tmd /b0x18B %wwpacker_iosHex%
	set wwpacker_signWAD=1
	set wwpacker_iosHex=
	set wwpacker_iosDec=
)
if %wwpacker_regionHex% GEQ 0 (
	echo _____________________________________________________________________
	if '%wwpacker_regionHex%'=='00' (
	echo Patch Region Flag to Japan...
	) else if '%wwpacker_regionHex%'=='01' (
	echo Patch Region Flag to USA...
	) else if '%wwpacker_regionHex%'=='02' (
	echo Patch Region Flag to Europe...
	) else if '%wwpacker_regionHex%'=='03' (
	echo Patch Region Flag to ALL Regions [RegionFree]...
	) else (
	echo Patch Region Flag to Region '%wwpacker_regionDec%' [Unknown]...
	)
	"%~dp0HTool.exe" /p _title.tmd /b0x19D %wwpacker_regionHex%
	set wwpacker_signWAD=1
	set wwpacker_regionHex=
	set wwpacker_regionDec=
)
:dlcRegionPatch
if %wwpacker_dlcRegionHex% LEQ 0 goto dlcRegionPatchEnd
	echo _____________________________________________________________________
	if '%wwpacker_dlcRegionHex%'=='4A' (
	echo Patch DLC Region Code to Japan...
	) else if '%wwpacker_dlcRegionHex%'=='45' (
	echo Patch DLC Region Code to USA...
	) else if '%wwpacker_dlcRegionHex%'=='50' (
	echo Patch DLC Region Code to Europe...
	) else if '%wwpacker_dlcRegionHex%'=='58' (
	echo Patch DLC Region Code to Europe[2]...
	) else (
	echo Patch DLC Region Code to '0x%wwpacker_dlcRegionHex%' [Unknown]...
	)
	for %%k in ("%~dp0htool.exe") do set wwpacker_htcmd=%%~fsk
	for %%k in ("%ComSpec%") do set wwpacker_findcmd=%%~dpk
	for %%k in ("%wwpacker_findcmd%find.exe") do set wwpacker_findcmd=%%~fsk
	for /F "tokens=3" %%k in ('%wwpacker_htcmd% /d /b0x1e0 /e0x1ec _title.tik ^| %wwpacker_findcmd% " : "') do set wwpacker_dlcTitle=%%k
	if '%wwpacker_dlcTitle:~2,6%'=='%wwpacker_dlcTitle:~18,6%' "%~dp0HTool.exe" /p _title.tik /b0x1EB %wwpacker_dlcRegionHex%
	"%~dp0HTool.exe" /p _title.tik /b0x1E3 %wwpacker_dlcRegionHex%
	"%~dp0HTool.exe" /p _title.tmd /b0x193 %wwpacker_dlcRegionHex%
	set wwpacker_signWAD=1
	set wwpacker_signOnlyTMD=0
	set wwpacker_htcmd=
	set wwpacker_findcmd=
	set wwpacker_dlcTitle=
	set wwpacker_dlcRegionHex=
:dlcRegionPatchEnd
:versionPatch
if %wwpacker_versionHex% LEQ 0 goto versionPatchEnd
	echo _____________________________________________________________________
	echo Patch Version to %wwpacker_versionDec%...
	for %%k in ("%~dp0waddatainfo.exe") do set wwpacker_cmd=%%~fsk
	for %%k in ("%ComSpec%") do set wwpacker_findcmd=%%~dpk
	for %%k in ("%wwpacker_findcmd%find.exe") do set wwpacker_findcmd=%%~fsk
	for /F "tokens=1" %%k in ('%wwpacker_cmd% /n _title.tik ^| %wwpacker_findcmd% /C /I "Version: "') do set wwpacker_tikGotVer=%%k
	for /F "tokens=1" %%k in ('%wwpacker_cmd% /n _title.tmd ^| %wwpacker_findcmd% /C /I "Version: "') do set wwpacker_tmdGotVer=%%k
	if %wwpacker_tikGotVer% EQU 1 "%~dp0HTool.exe" /p _title.tik /b0x1E6 %wwpacker_versionHex%
	if %wwpacker_tmdGotVer% EQU 1 "%~dp0HTool.exe" /p _title.tmd /b0x1DC %wwpacker_versionHex%
	set /A wwpacker_tmdGotVer += %wwpacker_tikGotVer%
	if %wwpacker_tmdGotVer% GTR 0 (
	set wwpacker_label=%wwpacker_label%[v%wwpacker_versionDec%]
	) else echo Version patch is not supported.
	set wwpacker_tmdGotVer=
	set wwpacker_tikGotVer=
	set wwpacker_cmd=
	set wwpacker_findcmd=
	set wwpacker_signWAD=1
	set wwpacker_signOnlyTMD=0
	set wwpacker_versionHex=
	set wwpacker_versionDec=
:versionPatchEnd
:changeTitleID
if "%wwpacker_titleId%"=="-1" goto changeTitleIDEnd
	echo _____________________________________________________________________
	echo Change TitleID to "%wwpacker_titleId%"...
	echo %wwpacker_titleId%>tmp_titleID.txt
	for %%k in ("%~dp0htool.exe") do set wwpacker_htcmd=%%~fsk
	for %%k in ("%ComSpec%") do set wwpacker_findcmd=%%~dpk
	for %%k in ("%wwpacker_findcmd%find.exe") do set wwpacker_findcmd=%%~fsk
	for /F "tokens=3" %%k in ('%wwpacker_htcmd% /d /b0 /e4 tmp_titleID.txt ^| %wwpacker_findcmd% " : "') do set wwpacker_titleId=%%k
	del /f /q tmp_titleID.txt
	if not '%wwpacker_titleId:~7,1%'=='' (
	"%~dp0HTool.exe" /p _title.tik /b0x1E0 %wwpacker_titleId%
	"%~dp0HTool.exe" /p _title.tmd /b0x190 %wwpacker_titleId%
	)
	set wwpacker_signWAD=1
	set wwpacker_signOnlyTMD=0
	set wwpacker_htcmd=
	set wwpacker_findcmd=
	set wwpacker_titleId=
:changeTitleIDEnd
:fakeTicketPatch
if %wwpacker_fakeTicket% LEQ 0 goto fakeTicketPatchEnd
	echo _____________________________________________________________________
	echo Apply the Fake Ticket patches...
	for %%k in ("%~dp0htool.exe") do set wwpacker_htcmd=%%~fsk
	for %%k in ("%ComSpec%") do set wwpacker_findcmd=%%~dpk
	for %%k in ("%wwpacker_findcmd%find.exe") do set wwpacker_findcmd=%%~fsk
	if %wwpacker_fakeTicket:~0,1% NEQ 0 (
	echo - Patch 1:TicketID
	"%~dp0HTool.exe" /p _title.tik /b0x1D0 0001ACE5E38E4C68 > NUL
	)
	if %wwpacker_fakeTicket:~1,1% NEQ 0 (
	echo - Patch 2:ConsoleID
	"%~dp0HTool.exe" /p _title.tik /b0x1D8 00000000 > NUL
	)
	if %wwpacker_fakeTicket:~2,1% NEQ 0 (
	echo - Patch 3:Reserved VC data
	"%~dp0HTool.exe" /p _title.tik /b0x180 /e0x1bf 00 > NUL
	)
:fakeTicketCode3
	if %wwpacker_fakeTicket:~3,1% EQU 0 goto fakeTicketCode3End
	echo - Patch 4:Amount of bought DLC contents
	for /F "tokens=3" %%k in ('%wwpacker_htcmd% /d /b0x1de /e0x1e0 "_title.tmd" ^| %wwpacker_findcmd% " : "') do set /A wwpacker_boughtDLCTotal=0x%%k - 2
	if %wwpacker_boughtDLCTotal% LSS 0 set /A wwpacker_boughtDLCTotal=0
	set decValue=%wwpacker_boughtDLCTotal%
	set hexLength=2
	set returnLabel=fakeTicketCode3D2H
	goto decToHex
:fakeTicketCode3D2H
	set wwpacker_boughtDLCTotal=%hexValue%
	set hexValue=
	set decValue=
	set hexLength=
	set returnLabel=
	"%~dp0HTool.exe" /p _title.tik /b0x1e6 %wwpacker_boughtDLCTotal% > NUL
	set wwpacker_boughtDLCTotal=
:fakeTicketCode3End
	if %wwpacker_fakeTicket:~4,1% NEQ 0 (
	echo - Patch 5:Reserved DLC data
	"%~dp0HTool.exe" /p _title.tik /b0x222 /e0x242 ff > NUL
	)
	set wwpacker_signWAD=1
	set wwpacker_signOnlyTMD=0
	set wwpacker_htcmd=
	set wwpacker_findcmd=
	set wwpacker_fakeTicket=
:fakeTicketPatchEnd

if %wwpacker_signWAD% GTR 0 if %wwpacker_signOnlyTMD% EQU 0 (
echo _____________________________________________________________________
echo Signing the ticket...
"%~dp0t-signer.exe" _title.tik
)
echo _____________________________________________________________________
echo Packing into WAD...
if '%wwpacker_label%'=='[Patched]' set wwpacker_label=[NoMod]
copy /Y /b "%~dp0common-key.bin"
if not %wwpacker_workFolder%=='' set ww_ipath=%~dpn1
set wwpacker_packFail=0
if %wwpacker_signWAD% EQU 0 (
"%~dp0bfgr_wadpacker.exe" _title.tik _title.tmd _title.cert "%ww_ipath% %wwpacker_label%.wad"
) else (
"%~dp0bfgr_wadpacker.exe" _title.tik _title.tmd _title.cert "%ww_ipath% %wwpacker_label%.wad" -M
)
if errorlevel 255 set wwpacker_packFail=1
if not %wwpacker_workFolder%=='' (
cd ..
rd /s /q "%wwpacker_workFolder%"
)
set wwpacker_signWAD=
set wwpacker_signOnlyTMD=
set wwpacker_label=
set wwpacker_workFolder=
cd "%~dp0"
if %wwpacker_packFail% EQU 1 goto main_error100
set wwpacker_packFail=
goto main_end


REM decToHex
REM [IN] %decValue% - decimal value
REM [IN] %hexLength% - the length of output %hexValue% in byte
REM [IN] %returnLabel% - the label to return when this function ends
REM [OUT] %hexValue% - hexadecimal value string without '0x' at the beginning
:decToHex
if %hexLength% LEQ 0 goto %returnLabel%
set /A hexBitLength=8
:decToHexByte
set /A dec4Bits="%decValue% & 0xF"
if %dec4Bits% EQU 10 ( set hexValue=A%hexValue%
) else if %dec4Bits% EQU 11 ( set hexValue=B%hexValue%
) else if %dec4Bits% EQU 12 ( set hexValue=C%hexValue%
) else if %dec4Bits% EQU 13 ( set hexValue=D%hexValue%
) else if %dec4Bits% EQU 14 ( set hexValue=E%hexValue%
) else if %dec4Bits% EQU 15 ( set hexValue=F%hexValue%
) else set hexValue=%dec4Bits%%hexValue%
set /A hexBitLength=%hexBitLength% - 4
set /A decValue="%decValue% >> 4"
set dec4Bits=
if %hexBitLength% GTR 0 goto decToHexByte
set hexBitLength=
set /A hexLength=%hexLength% - 1
goto decToHex


:main_error1
echo Error! Not enough parameters.
echo You should use the _wwpacker scripts instead of this one.
echo.
goto main_end


:main_error2
echo Error! Directory "%ww_ipath%" does not exist.
goto main_end


:main_error3
echo Error! Missing "%~dp0common-key.bin".
goto main_end


:main_error4
echo Error! Missing "%~dp0cert.sys".
goto main_end


:main_error5
echo Error! Missing "%~dp0loader.bin".
goto main_end


:main_error6
echo Error! Missing files in folder "%ww_ipath%".
goto main_end


:main_error100
set wwpacker_packFail=
echo Error! Fail to pack "%ww_ipath%".
echo.
pause
goto main_end


:main_end
echo _____________________________________________________________________
echo.
