@echo off
if "%~dpnx1"=="" goto unpack_error1
if not exist "%~dp0common-key.bin" goto unpack_error3
%ww_idrv%
cd "%ww_ipath%"
if not exist "%ww_iname%%ww_iext%" goto unpack_error2

set wwpacker_sameDir=0
if exist "common-key.bin" if exist "bfgr_wadunpacker.exe" if exist "cygcrypto-0.9.8.dll" if exist "cygwin1.dll" set wwpacker_sameDir=1
if %wwpacker_sameDir% EQU 0 (
copy /Y /b "%~dp0common-key.bin"
copy /Y /b "%~dp0bfgr_wadunpacker.exe"
copy /Y /b "%~dp0cygcrypto-0.9.8.dll"
copy /Y /b "%~dp0cygwin1.dll"
)

for %%k in ("%~dp0waddatainfo.exe") do set wwpacker_cmd=%%~fsk
for %%k in ("%ComSpec%") do set wwpacker_findcmd=%%~dpk
for %%k in ("%wwpacker_findcmd%find.exe") do set wwpacker_findcmd=%%~fsk
for /F "tokens=1,2" %%k in ('%wwpacker_cmd% /n "%ww_iname%%ww_iext%" ^| %wwpacker_findcmd% /I "Path: "') do if /I '%%k'=='Path:' set wwpacker_unpackFolder=%%l
for /F "tokens=1,3" %%k in ('%wwpacker_cmd% /n "%ww_iname%%ww_iext%" ^| %wwpacker_findcmd% /I "Data files: "') do if /I '%%k'=='Data' set wwpacker_contentTotal=%%l
set wwpacker_cmd=
set wwpacker_unpackFolder=%wwpacker_unpackFolder:~1,8%%wwpacker_unpackFolder:~10,8%
if exist "%wwpacker_unpackFolder%" rd /s /q "%wwpacker_unpackFolder%"

echo bfgr_wadunpacker.exe "%ww_iname%%ww_iext%"
set wwpacker_unpackFail=0
for /F "tokens=1" %%k in ('bfgr_wadunpacker.exe "%ww_iname%%ww_iext%" ^| %wwpacker_findcmd% /C /I "cid"') do if not %%k EQU %wwpacker_contentTotal% set wwpacker_unpackFail=1
if exist "%wwpacker_unpackFolder%" "%~dp0bfgrWadUnpackerWin_TitleFiles_Fix.exe" "%wwpacker_unpackFolder%\%wwpacker_unpackFolder%.tmd" "%wwpacker_unpackFolder%\%wwpacker_unpackFolder%.tik" "%wwpacker_unpackFolder%\%wwpacker_unpackFolder%.cert"
if exist "%wwpacker_unpackFolder%\%wwpacker_unpackFolder%.trailer" "%~dp0bfgrWadUnpackerWin_TitleFiles_Fix.exe" "%wwpacker_unpackFolder%\%wwpacker_unpackFolder%.trailer"
set wwpacker_unpackFolder=
set wwpacker_findcmd=
set wwpacker_contentTotal=
if %wwpacker_sameDir% EQU 0 (
del "common-key.bin"
del "bfgr_wadunpacker.exe"
del "cygcrypto-0.9.8.dll"
del "cygwin1.dll"
)
if %wwpacker_unpackFail% EQU 1 goto unpack_error100
set wwpacker_unpackFail=

set wwpacker_sameDir=
goto unpack_end


:unpack_error1
echo Error! Not enough parameters.
echo You should use the __wwunpacker script instead of this one.
echo.
goto unpack_end


:unpack_error2
echo Error! File "%ww_iname%%ww_iext%" does not exist.
goto unpack_end


:unpack_error3
echo Error! Missing "%~dp0common-key.bin".
goto unpack_end


:unpack_error100
set wwpacker_unpackFail=
echo Error! Fail to unpack "%ww_iname%%ww_iext%".
echo.
pause
goto unpack_end


:unpack_end
echo _____________________________________________________________________
echo.
